import { trace } from "loglevel"
import { TricksterAccount, TricksterInventory } from "../trickster"
import { v4 as uuidv4 } from 'uuid';
import axios, { AxiosRequestConfig, AxiosResponse } from "axios";

export const BankEndpoints = ["internal-xfer-item", "bank-item", "sell-item","buy-from-order","cancel-order"] as const
export type BankEndpoint = typeof BankEndpoints[number]

export interface LTOApi {
  GetInventory:(path:string)=>Promise<TricksterInventory>
  GetAccounts:() =>Promise<Array<TricksterAccount>>
  GetLoggedin:() =>Promise<boolean>

  BankAction:<T, D>(e:BankEndpoint, t:T) => Promise<D>
}
